import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.HashSet;

import java.util.Map;
import java.util.SortedMap;
import java.util.HashMap;
import java.util.TreeMap;

import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;

public class MapOfSetDemo {
    
    private Map<Person, Set<Person>> school;
    
    public MapOfSetDemo() {
        school = new HashMap<>();
    }
    
    public Collection<Person> getPupils(Person teacher) {
        return Collections.unmodifiableCollection(
           school.get(teacher));
    }
    
    public void addTeacher(Person t) {
        school.put(t, new TreeSet<Person>());
    }
    
    public void removeTeacher(Person t) {
        school.remove(t);
    }
    
    public void addPupil(Person teacher, Person pupil){
        if(teacher == null || pupil == null) 
            throw new NullPointerException("Neither teacher nor pupil can be null");
            
        Set<Person> pupils = school.get(teacher);
        if(pupils != null) {
            pupils.add(pupil);
        }
    }
    
    public void removePupil(Person teacher, Person pupil){
        Set<Person> pupils = school.get(teacher);
        if(pupils != null) {
            pupils.remove(pupil);
        }
    }
    
    public void run() {
        Person t1 = new Person("Pavel Horák", "1950/03/15");
        Person t2 = new Person("Kamil Hanák", "1977/09/25");
        
        addTeacher(t1);
        addTeacher(t2);
        
        addPupil(t1, new Person("Libor Žáček", "2000/03/15"));
        addPupil(t1, new Person("Kamila Žáčková", "2002/03/15"));
        
        addPupil(t2, new Person("Karel Žáček", "2001/03/15"));
        addPupil(t2, new Person("Karla Žáčková", "2003/03/15"));
        
        // pupils of teacher t1
        System.out.println("\nPupils of teacher "+t1);
        for(Person pupil: getPupils(t1)) {
            System.out.println(pupil);
        }
        
        // pupils of teacher t2
        System.out.println("\nPupils of teacher "+t2);
        for(Person pupil: getPupils(t2)) {
            System.out.println(pupil);
        }
    }
    
    public static void main(String[] args) {
        
        // create and run the demo of the school
        new MapOfSetDemo().run();
    }

}